/*
LICENCE
*******
Jquery Animated Grid Plugin
@Author : Denis Pissoort
is shared under the terms of the licence Creative Commons Paternité-Partage des Conditions Initiales à l'Identique 2.0 Belgique.
For more information : Author's work Page : http://dipi-graphics.com/javascript/jquery/plugin/animatedGrid/
                       Licence Page : http://creativecommons.org/licenses/by-sa/2.0/be/
*/

(function($) {
        // définition du plugin jQuery
        $.fn.animatedGrid = function(params) {
                // Fusionner les paramètres par défaut et ceux de l'utilisateur
                params = $.extend( {categorieClass: 'wrapCategorie', mainTitle: 'h2', subSection: 'dl', subTitle: 'dt', content: 'dd', autoCloseCell: false, speedAnimeWidth: 300, speedSlide: 'fast', activeCell: true}, params);
                // Traverser tous les nœuds.
                this.each(function() {
                        // Exprimer un nœud seul en objet jQuery
                        var $grid = $(this);
                        var wrapCategorie = params.categorieClass;
                        var titleM = params.mainTitle;
                        var subSection = params.subSection;
                        var titleS = params.subTitle;
                        var contentS = params.content;
                        var wrapCategorieGrid = params.categorieClass+'Grid';
                        if(titleM.indexOf('.',1) ==-1){
						var titleMGrid = params.mainTitle+'Grid';
                        }else{
                        var tagtemp = titleM.substring(0,titleM.indexOf('.',1));
                        var classtemp = titleM.substring(1+titleM.indexOf('.',1));
                        var titleMGrid = tagtemp+classtemp+'Grid';
                        }
                        if(subSection.indexOf('.',1) ==-1){
                        var subSectionGrid = params.subSection+'Grid';
                        }else{
                        var tagtemp = subSection.substring(0,subSection.indexOf('.',1));
                        var classtemp = subSection.substring(1+subSection.indexOf('.',1));
                        var subSectionGrid = tagtemp+classtemp+'Grid';
                        }
                        if(titleS.indexOf('.',1) ==-1){
                        var titleSGrid = params.subTitle+'Grid';
                        }else{
                        var tagtemp = titleS.substring(0,titleS.indexOf('.',1));
                        var classtemp = titleS.substring(1+titleS.indexOf('.',1));
                        var titleSGrid = tagtemp+classtemp+'Grid';
                        }
                        if(contentS.indexOf('.',1) ==-1){ 
                        var contentSGrid = params.content+'Grid';
                        }else{
                        var tagtemp = contentS.substring(0,contentS.indexOf('.',1));
                        var classtemp = contentS.substring(1+contentS.indexOf('.',1));
                        var contentSGrid = tagtemp+classtemp+'Grid';
                        }
                        var imgGrid = 'imgGrid';
                        var wrapCategorieGridActive = params.categorieClass+'GridActive';
                        var active='activeGrid';
                       
                       
                        /* START INIT PAGE */

// Add/Remove classes to style element with Js enable (see layout.css)
$grid.find('.'+wrapCategorie).addClass(wrapCategorieGrid);
$grid.find(titleM).addClass(titleMGrid);
$grid.find(subSection).addClass(subSectionGrid);
$grid.find(titleS).addClass(titleSGrid);	
$grid.find(contentS).addClass(contentSGrid);

//Hide content of all "dt.dtGrid"
$grid.find(contentS).hide();

/* Image Manager 
*****************
IF YOU ADD IMAGE IN YOUR CONTENT => just put an <img> as Child of Content then add the Height Attribute and set the correct height of your picture. This works only if your image Width is adapted to the row width. So Don't forget to prepare correctly your image to fit into your layout.
*/

$grid.find('img').addClass(imgGrid);
var imgArray = $grid.find('img').get();
var nbreImage = imgArray.length;
for (var i=0; i<nbreImage; i++) {
	$(imgArray[i]).data('height', $(imgArray[i]).attr('height') );
	}



// SET Active Main Section
$grid.find('.'+wrapCategorie).each(function(){
if($(this).hasClass(active)){
	     $(this).addClass(wrapCategorieGridActive);
		 $(this).removeClass(wrapCategorieGrid);
         $(this).removeClass(active);
        
          
	    };
 });
//Show content of Active Section
$grid.find(titleS+'.'+active).next().show();

/* END INIT PAGE */	

/* START HANDLER EVENT */

/* --------------MAIN SECTION -------------- */
//Be carefull here is a sample of animation for width. You have to adapt it for other Effect you want.

//FIRST define variable to stock value from the layout.css
var normalWidth = $grid.find("."+wrapCategorieGrid).css('width');
if(params.activeCell == true){
var activeWidth = $grid.find("."+wrapCategorieGridActive).css('width');
}else{
var activeWidth = params.activeCell;
}

//SECOND Click function 
$grid.find('.'+wrapCategorie).click(function(){
	
		if(!$(this).hasClass(wrapCategorieGridActive))
		{
			// START IMAGE MANAGER ONLY FIX STRANGE EFFECT WITH IMAGE RESIZE AND SLIDEDOWN 
			// IT's An extra fix no need to modify.
			for(var i=0; i<nbreImage; i++)
			 {
                  var tempImage = $(imgArray[i]);
		          if(! tempImage.parent().prev().hasClass(active))
				  {
					tempImage.attr('height', function(index, value){
                                  val = tempImage.data('height');
								  return val;
														   }); 
				  }else{
					 tempImage.removeAttr('height');
				  }
		     }
			 // END IMAGE MANAGER ONLY FIX STRANGE EFFECT WITH IMAGE RESIZE AND SLIDEDOWN
		
		 $grid.find('.'+wrapCategorieGridActive).stop().animate({width: normalWidth},params.speedAnimeWidth, 'linear');
		 $(this).stop().animate({width: activeWidth}, params.speedAnimeWidth, 'linear');
         $grid.find('.'+wrapCategorieGridActive).addClass(wrapCategorieGrid);
         $grid.find('.'+wrapCategorieGridActive).removeClass(wrapCategorieGridActive);
         $(this).addClass(wrapCategorieGridActive); 
		 // for more information, see: http://api.jquery.com/animate/  
	    }
});

/* --------------SUB SECTION -------------- */

$grid.find(titleS+'.'+titleSGrid).click(function(){
        
		if(!$(this).hasClass(active))
		{
        if(params.autoCloseCell){
          var Cell = $grid.find(titleS+'.'+titleSGrid).not(this);
          Cell.next().slideUp('fast');
          Cell.removeClass(active);
        };
        $(this).addClass(active);   
		$(this).next().slideDown(params.speedSlide);
		
		}else{
        $(this).removeClass(active);
		$(this).next().slideUp(params.speedSlide);
		
			};
							
});
                });
        // Permettre le chaînage par jQuery
        return this;
        };
})(jQuery);